/* Simple grammar with conflicts */
%{
    
  type exp =
    | Int of int
    | Cond of exp * exp * (exp option)

%}

/* Ocamlyacc Declarations */
%token LPAREN RPAREN PLUS 
%token IF THEN ELSE

%token EOF
%token <int> INT

%start prog

%type <exp> prog exp


/* Grammar follows */
%%
prog:
  | exp EOF { $1 }
;

exp:
  | INT			              { Int($1) }
  | LPAREN exp RPAREN	              { $2 }
  | IF b=exp THEN t=exp               { Cond(b, t, None) }
  | IF b=exp THEN t=exp ELSE f = exp  { Cond(b, t, Some f) }
;

%%
